#include <stdio.h>

/* Restituisce il numero di regine minacciate da quella in posizione (i,j). Se in posizione (i,j) non c'è 	una regina viene restituito 0 */
int contaMinacciate(int dim, int scacchiera[][dim], int i, int j);

/* Restituisce 1 se la configurazione della matrice scacchiera è valida (cioè ci sono n regine e nessuna ne minaccia un'altra), 0 altrimenti. */
int schemaValido(int dim, int scacchiera[][dim]);

int main(){
	int scacchiera[8][8]={
					{0,0,0,1,0,0,0,0},
					{0,0,0,0,0,0,1,0},
					{0,0,1,0,0,0,0,0},
					{0,0,0,0,0,0,0,1},
					{0,1,0,0,0,0,0,0},
					{0,0,0,0,1,0,0,0},
					{1,0,0,0,0,0,0,0},
					{0,0,0,0,0,1,0,0}
					};

	if(schemaValido(8,scacchiera))
		printf("Lo schema dato e' corretto\n");
	else
	printf("Lo schema dato NON e' corretto\n");

}

int contaMinacciate(int dim, int scacchiera[][dim], int i, int j){
	int count=0;

	//controlla riga
	for(int k=0;k<dim;k++){
		if(k!=j && scacchiera[i][k])
			count++;
	}

	//controlla colonna
	for(int h=0;h<dim;h++){
		if(h!=i && scacchiera[h][j])
			count++;
	}

	//controlla diagonale "negativa"
	int h=i-1;
	int k=j-1;
	while(h>=0 && k>=0){
		if(scacchiera[h][k])
			count++;
		h--;
		k--;
	}

	h=i+1;
	k=j+1;
	while(h<dim && k<dim){
		if(scacchiera[h][k])
			count++;
		h++;
		k++;
	}

	//controlla diagonale "positiva"
	h=i-1;
	k=j+1;
	while(h>=0 && k<dim){
		if(scacchiera[h][k])
			count++;
		h--;
		k++;
	}

	h=i+1;
	k=j-1;
	while(h<dim && k>=0){
		if(scacchiera[h][k])
			count++;
		h++;
		k--;
	}

	return count;
}

int schemaValido(int dim, int scacchiera[][dim]){
	int valida=1;
	int regine=0;

	int i=0;
	while(i<dim && valida){
		int j=0;
		while(j<dim && valida){
			if(scacchiera[i][j]){
				regine++;
				if(contaMinacciate(dim, scacchiera,i,j)!=0)
					valida=0;
			}
			j++;
		}
		i++;
	}
	valida=valida && (regine==dim);

	return valida;
}