#include <stdio.h>

int verificaSchema(int schema[][9]);
int verificaRiga(int schema[][9], int i);
int verificaColonna(int schema[][9], int j);
int verificaSettore(int schema[][9], int h, int k);

int main(){

	int sudoku[9][9]={
				{2,6,7,9,4,1,3,5,8},
				{4,8,1,2,3,5,9,7,6},
				{3,9,5,8,7,6,4,1,2},
				{1,4,6,7,2,3,8,9,5},
				{5,7,9,6,1,8,2,4,3},
				{8,2,3,5,9,4,1,6,7},
				{9,3,2,4,5,7,6,8,1},
				{6,5,4,1,8,2,7,3,9},
				{7,1,8,3,6,9,5,2,4}};

	if(verificaSchema(sudoku))
		printf("Lo schema dato e' corretto\n");
	else
		printf("Lo schema dato NON e' corretto\n");

}

int verificaSchema(int schema[][9]){
	int corretto=1;

	int i=0;
	while(i<9 && corretto){
		if(!verificaRiga(schema,i))
			corretto=0;
		i++;
	}

	int j=0;
	while(j<9 && corretto){
		if(!verificaColonna(schema,j))
			corretto=0;
		j++;
	}

	int h=0;
	while(h<9 && corretto){
		int k=0;
		while(k<9 && corretto){
			if(!verificaSettore(schema,h,k))
				corretto=0;

			k+=3;
		}
		h+=3;
	}


	return corretto;

}




int verificaRiga(int schema[][9], int i){

	int presenti[10]={0};


	for(int j=0;j<9;j++){
		int valore=schema[i][j];
		presenti[valore]=1;
	}

	int corretto=1;
	for(int j=1;j<10;j++)
		if(!presenti[j])
			corretto=0;

	return corretto;
}

int verificaColonna(int schema[][9], int j){

	int presenti[10]={0};


	for(int i=0;i<9;i++){
		int valore=schema[i][j];
		presenti[valore]=1;
	}

	int corretto=1;
	for(int i=1;i<10;i++)
		if(!presenti[i])
			corretto=0;

	return corretto;
}

int verificaSettore(int schema[][9], int h, int k){

	int presenti[10]={0};


	for(int i=h+0;i<=h+2;i++){
		for(int j=k+0;j<=k+2;j++){
			int valore=schema[i][j];
			presenti[valore]=1;
		}
	}

	int corretto=1;
	for(int i=1;i<10;i++)
		if(!presenti[i])
			corretto=0;

	return corretto;
}